Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tomcat.modules.config
Class IISConfig

    java.lang.Object
      org.apache.tomcat.core.BaseInterceptor
          org.apache.tomcat.modules.config.BaseJkConfig
              org.apache.tomcat.modules.config.IISConfig

public class IISConfig
extends BaseJkConfig

Generates automatic IIS isapi_redirect configurations based on the Tomcat server.xml settings and the war contexts initialized during startup.

This config interceptor is enabled by inserting an IISConfig element in the <ContextManager> tag body inside the server.xml file like so:

     < ContextManager ... >
       ...
       <IISConfig options />
       ...
     < /ContextManager >

where options can include any of the following attributes:

- configHome - default parent directory for the following paths. If not set, this defaults to TOMCAT_HOME. Ignored whenever any of the following paths is absolute.
- regConfig - path to use for writing IIS isapi_redirect registry file. If not set, defaults to "conf/auto/iis_redirect.reg".
- workersConfig - path to workers.properties file used by isapi_redirect. If not set, defaults to "conf/jk/workers.properties".
- uriConfig - path to use for writing IIS isapi_redirect uriworkermap file. If not set, defaults to "conf/auto/uriworkermap.properties".
- jkLog - path to log file to be used by isapi_redirect.
- jkDebug - Loglevel setting. May be debug, info, error, or emerg. If not set, defaults to emerg.
- jkWorker The desired worker. Must be set to one of the workers defined in the workers.properties file. "ajp12", "ajp13" or "inprocess" are the workers found in the default workers.properties file. If not specified, defaults to "ajp13" if an Ajp13Interceptor is in use, otherwise it defaults to "ajp12".
- forwardAll - If true, forward all requests to Tomcat. This helps insure that all the behavior configured in the web.xml file functions correctly. If false, let IIS serve static resources assuming it has been configured to do so. The default is true. Warning: When false, some configuration in the web.xml may not be duplicated in IIS. Review the uriworkermap file to see what configuration is actually being set in IIS.
- noRoot - If true, the root context is not mapped to Tomcat. If false and forwardAll is true, all requests to the root context are mapped to Tomcat. If false and forwardAll is false, only JSP and servlets requests to the root context are mapped to Tomcat. When false, to correctly serve Tomcat's root context you must also modify the Home Directory setting in IIS to point to Tomcat's root context directory. Otherwise some content, such as the root index.html, will be served by IIS before isapi_redirect gets a chance to claim the request and pass it to Tomcat. The default is true.

Version:
  $Revision: 1.15 $
Author:
  Costin Manolache, Larry Isaacs, Gal Shachor

Field Summary
`static java.lang.String` | `ISAPI_LOG_LOCATION`
`static java.lang.String` | `ISAPI_PROP_FILE`
`static java.lang.String` | `ISAPI_REDIRECTOR`
`static java.lang.String` | `ISAPI_REG_FILE`
`static java.lang.String` | `URI_WORKERS_MAP_CONFIG`
`static java.lang.String` | `WORKERS_CONFIG`

Fields inherited from class org.apache.tomcat.modules.config.BaseJkConfig
`configHome, forwardAll, jkDebug, jkLog, jkWorker, noRoot, regenerate, tomcatHome, workersConfig`

Fields inherited from class org.apache.tomcat.core.BaseInterceptor
`cm, ct, ctx, debug, DECLINED, loghelper, OK`

Constructor Summary
`IISConfig()`

Method Summary
`protected boolean` | `addExtensionMapping(java.lang.String ctxPath, java.lang.String ext, java.io.PrintWriter uri_worker)` Add an IIS extension mapping.
`protected boolean` | `addMapping(java.lang.String fullPath, java.io.PrintWriter uri_worker)` Add a fulling specified IIS mapping.
`void` | `execute(ContextManager cm)` executes the IISConfig interceptor.
`protected void` | `initProperties(ContextManager cm)` Initialize defaults for properties that are not set explicitely
`void` | `setIsapiRedirector(java.lang.String s)`
`void` | `setRegConfig(java.lang.String path)` set the path to the output file for the auto-generated isapi_redirect registry file.
`void` | `setUriConfig(java.lang.String path)` set a path to the uriworkermap.properties file.

Methods inherited from class org.apache.tomcat.modules.config.BaseJkConfig
`addInterceptor, addMapping, contextInit, engineState, getAbsoluteDocBase, initWorker, setConfigHome, setForwardAll, setJkDebug, setJkLog, setJkWorker, setNoRoot, setWorkersConfig`

Methods inherited from class org.apache.tomcat.core.BaseInterceptor
`addContainer, addContext, addHandler, addSecurityConstraint, afterBody, authenticate, authorize, beforeBody, beforeCommit, contextMap, contextShutdown, contextState, copyContext, engineInit, engineShutdown, engineStart, engineStop, findSession, getContext, getContextManager, getDebug, getInfo, getLog, getNote, getNote, handleError, log, log, log, log, postInitCheck, postReadRequest, postRequest, postService, postServletDestroy, postServletInit, preInitCheck, preService, preServletDestroy, preServletInit, registerHooks, reload, removeContainer, removeContext, removeHandler, removeInterceptor, requestMap, sessionState, setContext, setContextManager, setDebug, setInfo, setNote, setNote`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### WORKERS_CONFIG

    public static final java.lang.String WORKERS_CONFIG

See Also:
  Constant Field Values

### URI_WORKERS_MAP_CONFIG

    public static final java.lang.String URI_WORKERS_MAP_CONFIG

See Also:
  Constant Field Values

### ISAPI_LOG_LOCATION

    public static final java.lang.String ISAPI_LOG_LOCATION

See Also:
  Constant Field Values

### ISAPI_REG_FILE

    public static final java.lang.String ISAPI_REG_FILE

See Also:
  Constant Field Values

### ISAPI_PROP_FILE

    public static final java.lang.String ISAPI_PROP_FILE

See Also:
  Constant Field Values

### ISAPI_REDIRECTOR

    public static final java.lang.String ISAPI_REDIRECTOR

See Also:
  Constant Field Values

Constructor Detail

### IISConfig

    public IISConfig()

Method Detail

### setRegConfig

    public void setRegConfig(java.lang.String path)

  set the path to the output file for the auto-generated isapi_redirect registry file. If this path is relative then getRegConfig() will resolve it absolutely against the getConfigHome() path.

### setUriConfig

    public void setUriConfig(java.lang.String path)

  set a path to the uriworkermap.properties file.

### setIsapiRedirector

    public void setIsapiRedirector(java.lang.String s)

### initProperties

    protected void initProperties(ContextManager cm)

  Initialize defaults for properties that are not set explicitely

  Overrides:
    `initProperties` in class `BaseJkConfig`

### execute

    public void execute(ContextManager cm)
                 throws TomcatException

  executes the IISConfig interceptor. This method generates IIS configuration files for use with isapi_redirect. If not already set, this method will setConfigHome() to the value returned from cm.getHome().

  Overrides:
    `execute` in class `BaseJkConfig`
  Throws:
    `TomcatException`

### addExtensionMapping

    protected boolean addExtensionMapping(java.lang.String ctxPath,
                                          java.lang.String ext,
                                          java.io.PrintWriter uri_worker)

  Add an IIS extension mapping.

  Overrides:
    `addExtensionMapping` in class `BaseJkConfig`

### addMapping

    protected boolean addMapping(java.lang.String fullPath,
                                 java.io.PrintWriter uri_worker)

  Add a fulling specified IIS mapping.

  Overrides:
    `addMapping` in class `BaseJkConfig`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 Apache Software Foundation. All Rights Reserved.